#!/usr/bin/python
import sys, os, string, re
from optparse import OptionParser			

line = ""

def getExtLines(strFileName, strMemberName):
    docfile = open(strFileName)
    membername2 = ""
    commentline = ""
    outputtext = False

    lstLines = []

    for xmlline in docfile:
        commentline = xmlline.strip()
                
        if commentline.find('<member') >= 0:
            membername2 = string.replace(commentline, "<member name=\"", "")
            membername2 = string.replace(membername2, "\">", "")
            if membername2 == strMemberName: outputtext = True

        if commentline.startswith('</member>') and outputtext:
            return lstLines

        if outputtext and not commentline.startswith('<member'):
            lstLines.append('/// ' + xmlline.rstrip())
    return []
 
def main():
    global line

    parser = OptionParser()
    parser.add_option("-f", "--file",
        dest="inputfile",
        help="The source file to parse.",
        metavar="FILE")
    (options, args) = parser.parse_args()
    try:
        fh = open(options.inputfile)
    except:
        print "You must specify a valid text file using the -f option."

    (dirName, fileName) = os.path.split(options.inputfile)

    line = fh.readline()
    lstExtLines = []

    while line:
        if line.strip().startswith('///') and line.find('<include') >= 0:
            xmlfilename = ""
            membername = ""
            
            attach = False
            for word in line.split():
                if attach:
                    if re.search(']', word) > 0:
                        membername = membername + ' ' + word[0:word.index(']') - 1]
                        attach = False
                    else:
                        membername = membername + ' ' + word
                    
                if word.startswith('file='):
                    xmlfilename = word[6:(len(word)-1)]
                    if xmlfilename.startswith('\\'): xmlfilename = xmlfilename[1:len(filename)]
                    xmlfilename = dirName + '\\' + xmlfilename
                if word.startswith('path='):
                    if re.search(']', word) > 0: 
                        membername = word[word.index('[@name=') + 8:word.index(']') - 1]
                    else:
                        membername = word[word.index('[@name=') + 8:len(word)]
                        attach = True
        
            if xmlfilename is not "" and membername is not "":
                lstExtLines = getExtLines(xmlfilename, membername)
        else:
            print line.rstrip()

            
        if len(lstExtLines) == 0:
            line = fh.readline()
        else:
            line = lstExtLines.pop(0)

if __name__ == "__main__":
    main()
